/****************************************************************************
** Form interface generated from reading ui file '.\AOCAdminDialog.ui'
**
** Created: Fri Oct 10 18:14:55 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef ADMIN_DLG_H
#define ADMIN_DLG_H

#include <qvariant.h>
#include <qdialog.h>
#include "../common/aoc_proc.h"
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout;
class QHBox;
class QButtonGroup;
class QGroupBox;
class QScrollView;
class QComboBox;
class QLabel;
class QListView;
class QListViewItem;
class QListBox;
class QRadioButton;
class QPushButton;
class QTabWidget;
class QWidget;
class QMultiLineEdit;

class AOCAdminDialog : public QDialog
{ 
    Q_OBJECT

public:
    AOCAdminDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AOCAdminDialog();

	enum Types { Group, Process, Step, Item, GlobalItem };

    QLabel* ProcGroupLabel;
    QComboBox* ProcGroupList;
    QLabel* ProcessLabel;
    QComboBox* ProcessList;
	QTabWidget* ContentCtrl;
	QListBox* StepsList;
	QListView* StepDataList;
	QMultiLineEdit* StepNote;
	QListView* ItemsList;
	QListView* GlobalItemsList;
    QGroupBox* ActionBox;
	QButtonGroup* ActionTypeBox;
	QRadioButton* GroupBtn;
	QRadioButton* ProcessBtn;
	QRadioButton* StepBtn;
	QRadioButton* ProcItemBtn;
	QRadioButton* GlobItemBtn;
    QPushButton* AddBtn;
    QPushButton* EditBtn;
    QPushButton* DelBtn;
    QPushButton* SortBtn;
	QPushButton* SaveBtn;
	QPushButton* CopyBtn;
    QPushButton* ExitBtn;

protected slots:
    virtual void addAction();
    virtual void editAction();
    virtual void delAction();
    virtual void sortAction();
    virtual void selectGroup(int);
    virtual void selectProc(int);
	virtual void selectStep(int);
    virtual void selectType(int);
	virtual void saveData();
	virtual void copyItems();

protected:
    QVBoxLayout* BaseLayout;
    QGridLayout* SelectionLayout;
    QVBoxLayout* ActionBoxLayout;
	QHBoxLayout* ActionTypeLayout;
	QHBoxLayout* ActionBtnLayout;
    QHBoxLayout* SystemLayout;
	QWidget* StepsBox;
	QGridLayout* StepsBoxLayout;
	QHBox* ItemsBox;
	QHBox* GlobalItemsBox;

	void updateProcGrpList();
	void updateProcList();
	void updateStepsList();
	void updateStepDataList();
	void updateProcItemList();
	void updateItemsList();

	int Type;
};

#endif // ADMIN_DLG_H
