/****************************************************************************
** Form implementation generated from reading ui file '.\AOCrafterStepDialog.ui'
**
** Created: Thu Jan 22 17:07:21 2004
**	  by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "step_dlg.h"
#include "../common/aoc_names.h"
#include "../common/aoc_proc.h"

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qframe.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qmultilineedit.h>
#include <qmessagebox.h>

#include "../pixmaps/AOCrafter.xpm"

/* 
 *  Constructs a AOCrafterStepDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCrafterStepDialog::AOCrafterStepDialog( ItemList items, QWidget* parent,  const char* name, bool modal, WFlags fl )
	: QDialog( parent, name, modal, fl )
{
	if ( items.isEmpty() )
		return;
	else
		AvailItems = items;

	step.Item1.AOC_ID = 0;
	step.Item2.AOC_ID = 0;
	step.Product.AOC_ID = 0;

	if ( !name )
		setName( "AOCrafterStepDialog" );

	resize( 640, 400 ); 
	setCaption( tr( "AOCrafterAdmin" ) );
	setIcon( QPixmap( AOCrafter_xpm ) );
	AOCrafterStepDialogLayout = new QVBoxLayout( this ); 
	AOCrafterStepDialogLayout->setSpacing( 4 );
	AOCrafterStepDialogLayout->setMargin( 6 );

	StepFrame = new QFrame( this, "StepFrame" );
	StepFrame->setFrameShape( QFrame::Box );
	StepFrame->setFrameShadow( QFrame::Sunken );
	StepFrameLayout = new QGridLayout( StepFrame ); 
	StepFrameLayout->setSpacing( 4 );
	StepFrameLayout->setMargin( 6 );

	ActionBox = new QComboBox( FALSE, StepFrame, "ActionBox" );
	for( int i = 0; i < Names.getActions(); i++ )
	{
		ActionBox->insertItem( Names.getAction( i ) );
	}
	ActionBox->setSizePolicy( QSizePolicy( QSizePolicy::Minimum, QSizePolicy::Fixed, ActionBox->sizePolicy().hasHeightForWidth() ) );
	ActionBox->setEditable( FALSE );
	ActionBox->setDuplicatesEnabled( FALSE );

	StepFrameLayout->addWidget( ActionBox, 0, 0 );

	Item1Box = new QLabel( StepFrame, "Item1Box" );
	Item1Box->setFrameStyle( QLabel::Panel | QLabel::Sunken );
	Item1Box->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Preferred, Item1Box->sizePolicy().hasHeightForWidth() ) );

	StepFrameLayout->addWidget( Item1Box, 0, 1 );

	EditItem1Btn = new QPushButton( StepFrame, "EditItem1Btn" );
	EditItem1Btn->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, EditItem1Btn->sizePolicy().hasHeightForWidth() ) );
	EditItem1Btn->setText( tr( ">>" ) );
	EditItem1Btn->setFixedSize( 24, 24 );
	EditItem1Btn->setAutoDefault( FALSE );

	StepFrameLayout->addWidget( EditItem1Btn, 0, 2 );

	OnLabel = new QLabel( StepFrame, "OnLabel" );
	OnLabel->setText( tr( "on" ) );
	OnLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

	StepFrameLayout->addWidget( OnLabel, 1, 0 );

	Item2Box = new QLabel( StepFrame, "Item2Box" );
	Item2Box->setFrameStyle( QLabel::Panel | QLabel::Sunken );
	Item2Box->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Preferred, Item2Box->sizePolicy().hasHeightForWidth() ) );

	StepFrameLayout->addWidget( Item2Box, 1, 1 );

	EditItem2Btn = new QPushButton( StepFrame, "EditItem2Btn" );
	EditItem2Btn->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, EditItem2Btn->sizePolicy().hasHeightForWidth() ) );
	EditItem2Btn->setText( tr( ">>" ) );
	EditItem2Btn->setFixedSize( 24, 24 );
	EditItem2Btn->setAutoDefault( FALSE );

	StepFrameLayout->addWidget( EditItem2Btn, 1, 2 );

	ProductLabel = new QLabel( StepFrame, "ProductLabel" );
	ProductLabel->setText( tr( "makes" ) );
	ProductLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

	StepFrameLayout->addWidget( ProductLabel, 2, 0 );

	ProductBox = new QLabel( StepFrame, "ProductBox" );
	ProductBox->setFrameStyle( QLabel::Panel | QLabel::Sunken );
	ProductBox->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Preferred, ProductBox->sizePolicy().hasHeightForWidth() ) );

	StepFrameLayout->addWidget( ProductBox, 2, 1 );

	EditProductBtn = new QPushButton( StepFrame, "EditProductBtn" );
	EditProductBtn->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, EditProductBtn->sizePolicy().hasHeightForWidth() ) );
	EditProductBtn->setText( tr( ">>" ) );
	EditProductBtn->setFixedSize( 24, 24 );
	EditProductBtn->setAutoDefault( FALSE );

	StepFrameLayout->addWidget( EditProductBtn, 2, 2 );

	SkillBox = new QGroupBox( StepFrame, "SkillBox" );
	SkillBox->setTitle( tr( "Needed skills:" ) );
	SkillBox->setColumnLayout(0, Qt::Vertical );
	SkillBox->layout()->setSpacing( 0 );
	SkillBox->layout()->setMargin( 0 );
	SkillBoxLayout = new QHBoxLayout( SkillBox->layout() );
	SkillBoxLayout->setAlignment( Qt::AlignTop );
	SkillBoxLayout->setSpacing( 4 );
	SkillBoxLayout->setMargin( 6 );

	SkillsList = new QListView( SkillBox, "SkillsList" );
	SkillsList->header()->setClickEnabled( FALSE );
	SkillsList->header()->setResizeEnabled( FALSE );
	SkillsList->addColumn( "#" );
	SkillsList->addColumn( tr( "Skill" ) );
	SkillsList->addColumn( tr( "Multiplier" ) );
	SkillsList->setAllColumnsShowFocus( TRUE );
	SkillsList->setLineWidth( 1 );
	SkillBoxLayout->addWidget( SkillsList );

	SkillsLayout = new QVBoxLayout; 
	SkillsLayout->setSpacing( 4 );
	SkillsLayout->setMargin( 0 );

	EditSkillBtn = new QPushButton( SkillBox, "EditSkillBtn" );
	EditSkillBtn->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, EditSkillBtn->sizePolicy().hasHeightForWidth() ) );
	EditSkillBtn->setText( tr( ">>" ) );
	EditSkillBtn->setFixedSize( 24, 24 );
	EditSkillBtn->setAutoDefault( FALSE );

	SkillsLayout->addWidget( EditSkillBtn );

	DelSkillBtn = new QPushButton( SkillBox, "DelSkillBtn" );
	DelSkillBtn->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, DelSkillBtn->sizePolicy().hasHeightForWidth() ) );
	DelSkillBtn->setText( tr( "X" ) );
	DelSkillBtn->setFixedSize( 24, 24 );
	DelSkillBtn->setAutoDefault( FALSE );

	SkillsLayout->addWidget( DelSkillBtn );
	QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
	SkillsLayout->addItem( spacer );
	SkillBoxLayout->addLayout( SkillsLayout );

	StepFrameLayout->addMultiCellWidget( SkillBox, 3, 5, 0, 2 );

	ReqFrame = new QGroupBox( StepFrame, "ReqFrame" );
	ReqFrame->setTitle( tr( "New Skill" ) );
	ReqFrame->setColumnLayout(0, Qt::Vertical );
	ReqFrame->layout()->setSpacing( 0 );
	ReqFrame->layout()->setMargin( 0 );
	ReqFrameLayout = new QGridLayout( ReqFrame->layout() );
	ReqFrameLayout->setAlignment( Qt::AlignTop );
	ReqFrameLayout->setSpacing( 4 );
	ReqFrameLayout->setMargin( 6 );

	NameLabel = new QLabel( ReqFrame, "NameLabel" );
	NameLabel->setText( tr( "&Name" ) );
	ReqFrameLayout->addWidget( NameLabel, 0, 0 );

	NameBox = new QComboBox( ReqFrame, "NameBox" );
	ReqFrameLayout->addMultiCellWidget( NameBox, 0, 0, 1, 3 );

	MultiLabel = new QLabel( ReqFrame, "MultiLabel" );
	MultiLabel->setText( tr( "&Multiplier" ) );
	ReqFrameLayout->addWidget( MultiLabel, 1, 0 );

	MultiEdit = new QLineEdit( ReqFrame, "MultiEdit" );
	ReqFrameLayout->addMultiCellWidget( MultiEdit, 1, 1, 1, 2 );

	FixedBox = new QCheckBox( ReqFrame, "FixedBox" );
	FixedBox->setText( tr( "Fixed" ) );
	ReqFrameLayout->addWidget( FixedBox, 1, 3 );

	AddBtn = new QPushButton( ReqFrame, "AddBtn" );
	AddBtn->setText( tr( "Add" ) );
	AddBtn->setDefault( TRUE );
	ReqFrameLayout->addMultiCellWidget( AddBtn, 2, 2, 0, 3 );

	StepFrameLayout->addMultiCellWidget( ReqFrame, 0, 3, 3, 3 );

	CountLayout = new QHBoxLayout; 
	CountLayout->setSpacing( 4 );
	CountLayout->setMargin( 0 );

	CountLabel = new QLabel( StepFrame, "CountLabel" );
	CountLabel->setText( tr( "Step &repeat count:" ) );
	CountLayout->addWidget( CountLabel );

	CountBox = new QSpinBox( 1, 100, 1, StepFrame, "CountEdit" );
	CountLayout->addWidget( CountBox );

	StepFrameLayout->addLayout( CountLayout, 4, 3 );

	NoteBox = new QGroupBox( StepFrame, "NoteBox" );
	NoteBox->setTitle( tr( "Notes:" ) );
	NoteBox->setColumnLayout( 0, Qt::Vertical );
	NoteBox->layout()->setSpacing( 0 );
	NoteBox->layout()->setMargin( 0 );
	NoteBoxLayout = new QVBoxLayout( NoteBox->layout() );
	NoteBoxLayout->setAlignment( Qt::AlignTop );
	NoteBoxLayout->setSpacing( 4 );
	NoteBoxLayout->setMargin( 6 );

	NoteEdit = new QMultiLineEdit( NoteBox, "NoteEdit" );
	NoteBoxLayout->addWidget( NoteEdit );

	SaveNoteBtn = new QPushButton( NoteBox, "SaveNoteBtn" );
	SaveNoteBtn->setText( tr( "Save" ) );
	NoteBoxLayout->addWidget( SaveNoteBtn );

	StepFrameLayout->addWidget( NoteBox, 5, 3 );

	SysLayout = new QHBoxLayout; 
	SysLayout->setSpacing( 4 );
	SysLayout->setMargin( 0 );

	OkBtn = new QPushButton( StepFrame, "OkBtn" );
	OkBtn->setCaption( tr( "" ) );
	OkBtn->setText( tr( "&OK" ) );
	OkBtn->setAutoDefault( TRUE );
	SysLayout->addWidget( OkBtn );

	CancelBtn = new QPushButton( StepFrame, "CancelBtn" );
	CancelBtn->setText( tr( "&Cancel" ) );
	CancelBtn->setAutoDefault( TRUE );
	SysLayout->addWidget( CancelBtn );

	StepFrameLayout->addMultiCellLayout( SysLayout, 6, 6, 0, 3 );

	AOCrafterStepDialogLayout->addWidget( StepFrame );

	// signals and slots connections
	connect( ActionBox, SIGNAL( activated(int) ), this, SLOT( setAction(int) ) );
	connect( EditItem1Btn, SIGNAL( clicked() ), this, SLOT( editItem1() ) );
	connect( EditItem2Btn, SIGNAL( clicked() ), this, SLOT( editItem2() ) );
	connect( EditProductBtn, SIGNAL( clicked() ), this, SLOT( editProduct() ) );
	connect( EditSkillBtn, SIGNAL( clicked() ), this, SLOT( editSkill() ) );
	connect( DelSkillBtn, SIGNAL( clicked() ), this, SLOT( deleteSkill() ) );
	connect( FixedBox, SIGNAL( toggled(bool) ), this, SLOT( setFixed(bool) ) );
	connect( AddBtn, SIGNAL( clicked() ), this, SLOT( addItem() ) );
	connect( CountBox, SIGNAL( valueChanged(int) ), this, SLOT( setCount(int) ) );
	connect( SaveNoteBtn, SIGNAL( clicked() ), this, SLOT( saveNote() ) );
	connect( OkBtn, SIGNAL( clicked() ), this, SLOT( accept() ) );
	connect( CancelBtn, SIGNAL( clicked() ), this, SLOT( reject() ) );

	// tab order
	setTabOrder( ActionBox, Item1Box );
	setTabOrder( Item1Box, Item2Box );
	setTabOrder( Item2Box, ProductBox );
	setTabOrder( ProductBox, EditItem1Btn );
	setTabOrder( EditItem1Btn, EditItem2Btn );
	setTabOrder( EditItem2Btn, EditProductBtn );
	setTabOrder( EditProductBtn, NameBox );
	setTabOrder( NameBox, MultiEdit );
	setTabOrder( MultiEdit, FixedBox );
	setTabOrder( FixedBox, AddBtn );
	setTabOrder( AddBtn, SkillsList );
	setTabOrder( SkillsList, EditSkillBtn );
	setTabOrder( EditSkillBtn, DelSkillBtn );
	setTabOrder( DelSkillBtn, NoteEdit );
	setTabOrder( NoteEdit, SaveNoteBtn );
	setTabOrder( SaveNoteBtn, OkBtn );
	setTabOrder( OkBtn, CancelBtn );

	// buddies
	NameLabel->setBuddy( NameBox );
	MultiLabel->setBuddy( MultiEdit );
	CountLabel->setBuddy( CountBox );

	setAction( 0 );
	updateData();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCrafterStepDialog::~AOCrafterStepDialog()
{
	// no need to delete child widgets, Qt does it all for us
}

void AOCrafterStepDialog::updateData()
{
	setAction( step.Action );
	Item1Box->setText( getItemByID( step.Item1.AOC_ID ).Name );
	Item2Box->setText( getItemByID( step.Item2.AOC_ID ).Name );
	ProductBox->setText( getItemByID( step.Product.AOC_ID ).Name );

	SkillsList->clear();
	QListViewItem *item = 0;
	for( int n = 0; n < (int) step.Skills.count(); n++ )
	{
		AOCReq rSkill = step.Skills[n];
		item = new QListViewItem( SkillsList, item );
		item->setText( 0, QString( "%1" ).arg( n ) );
		item->setText( 1, Names.getSkill( rSkill.AOC_ID ) );
		item->setText( 2, QString( "%1" ).arg( rSkill.Multiplier ) );
	}

	listItems( FALSE );
	MultiEdit->clear();
	setFixed( FALSE );
	ReqFrame->setTitle( tr( "New Skill" ) );
	AddBtn->setText( tr( "Add" ) );
	EditMode = AddSkill;
	CountBox->setValue( step.Count );
	NoteEdit->setText( step.Note );
}

int AOCrafterStepDialog::getItemIndexByID( Q_UINT32 ID )
{
	for( int n = 0; n < (int) AvailItems.count(); n++ )
	{
		if( AvailItems[n].AOC_ID == ID )
		{
			return n;
		}
	}
	return -1;
}

AOCItem AOCrafterStepDialog::getItemByIndex( int index )
{
	if( index >= 0 && index < (int) AvailItems.count() )
	{
		return AvailItems[index];
	}
	AOCItem ret;
	ret.AOC_ID = 0;
	ret.Name= "";
	ret.AOdbID = 0;
	ret.MinQL = 0.0;
	ret.MaxQL = 0.0;
	return ret;
}

AOCItem AOCrafterStepDialog::getItemByID( Q_UINT32 ID )
{
	return getItemByIndex( getItemIndexByID( ID ) );
}

void AOCrafterStepDialog::listItems( bool items )
{
	NameBox->clear();
	int n = 0;
	if( items == TRUE )
	{
		aocDebug( "listing items (%d)", AvailItems.count() );
		for( n = 0; n < (int) AvailItems.count(); n++ )
		{
			NameBox->insertItem( AvailItems[n].Name );
		}
	}
	else
	{
		aocDebug( "listing skills (%d)", Names.getSkills() );
		for( n = 0; n < Names.getSkills(); n++ )
		{
			NameBox->insertItem( Names.getSkill( n ) );
		}
	}
}

void AOCrafterStepDialog::addItem()
{
	AOCReq tmpSkill;
	if( NameBox->currentText() != "" )
	{
		switch( EditMode ) 
		{
		case AddSkill:
			tmpSkill.AOC_ID = NameBox->currentItem();
			tmpSkill.Multiplier = MultiEdit->text().toDouble();
			step.Skills.append( tmpSkill );
			break;
		case EditSkill:
			step.Skills[selSkill].AOC_ID = NameBox->currentItem();
			step.Skills[selSkill].Multiplier = MultiEdit->text().toDouble();
			break;
		case EditItem1:
			step.Item1.AOC_ID = getItemByIndex( NameBox->currentItem() ).AOC_ID;
			step.Item1.Multiplier = MultiEdit->text().toDouble();
			break;
		case EditItem2:
			step.Item2.AOC_ID = getItemByIndex( NameBox->currentItem() ).AOC_ID;
			step.Item2.Multiplier = MultiEdit->text().toDouble();
			break;
		case EditProduct:
			step.Product.AOC_ID = getItemByIndex( NameBox->currentItem() ).AOC_ID;
			step.Product.Multiplier = MultiEdit->text().toDouble();
			break;
		default:
			qWarning( "AOCrafterStepDialog::addItem(): EditMode not set!" );
			break;
		}
	}
	updateData();
}

void AOCrafterStepDialog::deleteSkill()
{
	if( QListViewItem *skill = SkillsList->currentItem() )
	{
		selSkill = skill->text( 0 ).toInt();
		step.Skills.remove( step.Skills.at( selSkill ) );
	}
	updateData();
}

void AOCrafterStepDialog::editItem1()
{
	EditMode = EditItem1;
	listItems( TRUE );
	if( step.Item1.AOC_ID != 0 )
	{
		NameBox->setCurrentItem( getItemIndexByID( step.Item1.AOC_ID ) );
		MultiEdit->setText( QString( "%1" ).arg( step.Item1.Multiplier ) );
		if( step.Item1.Multiplier == 0.0 )
			setFixed( TRUE );
		else
			setFixed( FALSE );
	}
	else
	{
		MultiEdit->clear();
		setFixed( FALSE );
	}
	ReqFrame->setTitle( tr( "Editing Item1..." ) );
	AddBtn->setText( tr( "Save" ) );
}

void AOCrafterStepDialog::editItem2()
{
	EditMode = EditItem2;
	listItems( TRUE );
	if( step.Item2.AOC_ID != 0 )
	{
		NameBox->setCurrentItem( getItemIndexByID( step.Item2.AOC_ID ) );
		MultiEdit->setText( QString( "%1" ).arg( step.Item2.Multiplier ) );
		if( step.Item2.Multiplier == 0.0 )
			setFixed( TRUE );
		else
			setFixed( FALSE );
	}
	else
	{
		MultiEdit->clear();
		setFixed( FALSE );
	}
	ReqFrame->setTitle( tr( "Editing Item2..." ) );
	AddBtn->setText( tr( "Save" ) );
}

void AOCrafterStepDialog::editProduct()
{
	EditMode = EditProduct;
	listItems( TRUE );
	if( step.Product.AOC_ID != 0 )
	{
		NameBox->setCurrentItem( getItemIndexByID( step.Product.AOC_ID ) );
		MultiEdit->setText( QString( "%1" ).arg( step.Product.Multiplier ) );
		if( step.Product.Multiplier == 0.0 )
			setFixed( TRUE );
		else
			setFixed( FALSE );
	}
	else
	{
		MultiEdit->clear();
		setFixed( FALSE );
	}
	ReqFrame->setTitle( tr( "Editing Product..." ) );
	AddBtn->setText( tr( "Save" ) );
}

void AOCrafterStepDialog::editSkill()
{
	if( QListViewItem *skill = SkillsList->currentItem() )
	{
		selSkill = skill->text( 0 ).toInt();
		EditMode = EditSkill;
		NameBox->setCurrentItem( step.Skills[selSkill].AOC_ID );
		MultiEdit->setText( QString( "%1" ).arg( step.Skills[selSkill].Multiplier ) );
		if( step.Skills[selSkill].Multiplier == 0.0 )
			setFixed( TRUE );
		ReqFrame->setTitle( tr( "Editing Skill %1..." ).arg( selSkill ) );
		AddBtn->setText( tr( "Save" ) );
	}
	else
	{
		QMessageBox::information( this, "AOCrafterAdmin",
			tr( "Please select a skill before you try to edit it..." ) );
	}
}

void AOCrafterStepDialog::setFixed( bool checked )
{
	MultiEdit->setEnabled( !checked );
	if( checked ) MultiEdit->setText( "0" );
	FixedBox->setChecked( checked );
}

void AOCrafterStepDialog::saveNote()
{
	step.Note = NoteEdit->text();
}

void AOCrafterStepDialog::setAction( int action )
{
	if( action > ActionBox->count() ) return;
	aocDebug( "Changing action! Was %d, now %d", step.Action, action );
	step.Action = action;
	ActionBox->setCurrentItem( action );
}

void AOCrafterStepDialog::setCount( int count )
{
	if( count < 1 || count > 100 ) return;
	aocDebug( "Changing repeat count! Was %d, now %d", step.Count, count );
	step.Count = count;
}