/****************************************************************************
** Form implementation generated from reading ui file '..\client\ui-files\about_dlg.ui'
**
** Created: Fri Mar 5 19:03:46 2004
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "about_dlg.h"
#include "../common/aoc_version.h"
#include <qgroupbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "../pixmaps/AOCrafter.xpm"
#include "../pixmaps/Arcanum.xpm"
#include "../pixmaps/Mainframe.xpm"

/* 
 *  Constructs a AOCAboutDlg which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCAboutDlg::AOCAboutDlg( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "AOCAboutDlg" );
    resize( 450, 320 ); 
    setCaption( tr( "About AOCrafter v%1" ).arg( AOC_VERSION ) );
    QPixmap *icon = new QPixmap( AOCrafter_xpm );
    setIcon( *icon );
    AboutDlgLayout = new QVBoxLayout( this ); 
    AboutDlgLayout->setSpacing( 4 );
    AboutDlgLayout->setMargin( 6 );

	QString AboutText = QString(
		"<font size=7><b><center>AOCrafter v%1</center></b></font>"
		"<b><center>&copy; Copyright 2004  Mawerick</center></b><hr>"

		"AOCrafter is a small tool that will help you see what items and skills you need to"
		" perform certain crafting skills in Anarchy Online.<br>"

		"Most of the information used in this tool was found on the site"
		" <a href=\"http://www.anarchyarcanum.com\">Anarchy Arcanum</a>,"
		" and much thanks go out to the crew there for all their hard work.<br><br>"

		"For feedback, questions or flames, please contact me on"
		" <a href=\"mailto:mawerick@wrongplace.net\">mawerick@wrongplace.net</a>."
	).arg( AOC_VERSION );

    AboutBox = new QGroupBox( this, "AboutBox" );
    AboutBox->setTitle( tr( "About AOCrafter:" ) );
    AboutBox->setColumnLayout(0, Qt::Vertical );
    AboutBox->layout()->setSpacing( 0 );
    AboutBox->layout()->setMargin( 0 );
    AboutBoxLayout = new QVBoxLayout( AboutBox->layout() );
    AboutBoxLayout->setAlignment( Qt::AlignTop );
    AboutBoxLayout->setSpacing( 4 );
    AboutBoxLayout->setMargin( 6 );

    AboutLabel = new QLabel( AboutBox, "AboutLabel" );
	AboutLabel->setAlignment( Qt::WordBreak );
	AboutLabel->setTextFormat( Qt::RichText );
    AboutLabel->setText( tr( AboutText ) );
    AboutBoxLayout->addWidget( AboutLabel );
    AboutDlgLayout->addWidget( AboutBox );

    CreditsBox = new QGroupBox( this, "CreditsBox" );
    CreditsBox->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)4, CreditsBox->sizePolicy().hasHeightForWidth() ) );
    CreditsBox->setTitle( tr( "Thanks to:" ) );
    CreditsBox->setColumnLayout(0, Qt::Vertical );
    CreditsBox->layout()->setSpacing( 0 );
    CreditsBox->layout()->setMargin( 0 );
    CreditsBoxLayout = new QGridLayout( CreditsBox->layout() );
    CreditsBoxLayout->setAlignment( Qt::AlignTop );
    CreditsBoxLayout->setSpacing( 4 );
    CreditsBoxLayout->setMargin( 6 );

    ArcanumPixLabel = new QLabel( CreditsBox, "ArcanumPixLabel" );
    ArcanumPixLabel->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, ArcanumPixLabel->sizePolicy().hasHeightForWidth() ) );
    ArcanumPixLabel->setFixedSize( QSize( 185, 54 ) );
    ArcanumPixLabel->setFrameShape( QLabel::Box );
    ArcanumPixLabel->setFrameShadow( QLabel::Plain );
    ArcanumPixLabel->setLineWidth( 1 );
    ArcanumPixLabel->setPixmap( QPixmap( Arcanum_xpm ) );
    ArcanumPixLabel->setScaledContents( FALSE );
    ArcanumPixLabel->setIndent( 0 );

    CreditsBoxLayout->addWidget( ArcanumPixLabel, 0, 0 );

    ArcanumLinkLabel = new QLabel( CreditsBox, "ArcanumLinkLabel" );
	ArcanumLinkLabel->setText( tr( "<a href=\"http://www.anarchyarcanum.com\">http://www.anarchyarcanum.com</a>" ) );
	ArcanumLinkLabel->setAlignment( int( QLabel::AlignCenter ) );

    CreditsBoxLayout->addWidget( ArcanumLinkLabel, 1, 0 );

    MainframePixLabel = new QLabel( CreditsBox, "MainframePixLabel" );
    MainframePixLabel->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, MainframePixLabel->sizePolicy().hasHeightForWidth() ) );
    MainframePixLabel->setFixedSize( QSize( 185, 54 ) );
    MainframePixLabel->setFrameShape( QLabel::Box );
    MainframePixLabel->setFrameShadow( QLabel::Plain );
    MainframePixLabel->setLineWidth( 1 );
    MainframePixLabel->setPixmap( QPixmap( Mainframe_xpm ) );
    MainframePixLabel->setScaledContents( FALSE );
    MainframePixLabel->setIndent( 0 );

    CreditsBoxLayout->addWidget( MainframePixLabel, 0, 1 );

    MainframeLinkLabel = new QLabel( CreditsBox, "MainframeLinkLabel" );
    MainframeLinkLabel->setText( tr( "<a href=\"http://www.aodb.info\">http://www.aodb.info</a>" ) );
    MainframeLinkLabel->setAlignment( int( QLabel::AlignCenter ) );

    CreditsBoxLayout->addWidget( MainframeLinkLabel, 1, 1 );
    AboutDlgLayout->addWidget( CreditsBox );

    Layout1 = new QHBoxLayout; 
    Layout1->setSpacing( 4 );
    Layout1->setMargin( 0 );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer );

    OkBtn = new QPushButton( this, "OkBtn" );
    OkBtn->setText( tr( "&Ok" ) );
    OkBtn->setDefault( TRUE );
    Layout1->addWidget( OkBtn );

    QSpacerItem* spacer_2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer_2 );
    AboutDlgLayout->addLayout( Layout1 );

    // signals and slots connections
    connect( OkBtn, SIGNAL( clicked() ), this, SLOT( accept() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCAboutDlg::~AOCAboutDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

