/****************************************************************************
** Form implementation generated from reading ui file 'ui-files\client_dlg.ui'
**
** Created: Wed Oct 8 19:49:31 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "client_dlg.h"
#include "about_dlg.h"
#include "../common/aoc_proc.h"
#include "../common/aoc_names.h"
#include "../common/aoc_version.h"
#include <qaccel.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qtabwidget.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qurloperator.h>

#include "../pixmaps/AOCrafter.xpm"

/* 
 *  Constructs a AOCrafterDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCrafterDialog::AOCrafterDialog( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "AOCrafterDialog" );
    resize( 550, 480 ); 
    setCaption( tr( "AOCrafter v%1" ).arg( AOC_VERSION ) );
    QPixmap *icon = new QPixmap( AOCrafter_xpm );
    setIcon( *icon );
    setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, sizePolicy().hasHeightForWidth() ) );

    BaseLayout = new QVBoxLayout( this ); 
    BaseLayout->setSpacing( 6 );
    BaseLayout->setMargin( 10 );

    Layout4 = new QGridLayout;
    Layout4->setSpacing( 6 );
    Layout4->setMargin( 0 );

    ProcGrpLabel = new QLabel( this, "ProcGrpLabel" );
    ProcGrpLabel->setText( tr( "Tradeskill Groups" ) );

    Layout4->addWidget( ProcGrpLabel, 0, 0 );

    ProcGrpList = new QComboBox( FALSE, this, "ProcGrpList" );
    ProcGrpList->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, ProcGrpList->sizePolicy().hasHeightForWidth() ) );
    ProcGrpList->setCurrentItem( 0 );

    Layout4->addMultiCellWidget( ProcGrpList, 0, 0, 1, 2 );

    ProcessLabel = new QLabel( this, "ProcessLabel" );
    ProcessLabel->setText( tr( "Tradeskill Process" ) );

    Layout4->addWidget( ProcessLabel, 1, 0 );

    ProcessList = new QComboBox( FALSE, this, "ProcessList" );
    ProcessList->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, ProcessList->sizePolicy().hasHeightForWidth() ) );

    Layout4->addMultiCellWidget( ProcessList, 1, 1, 1, 2 );

    QualityLabel = new QLabel( this, "QualityLabel" );
    QualityLabel->setText( tr( "Product Quality" ) );

    Layout4->addWidget( QualityLabel, 2, 0 );

    QualitySlider = new QSlider( 1, 300, 10, 1, QSlider::Horizontal, this, "QualitySlider" );
    QualitySlider->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Fixed, QualitySlider->sizePolicy().hasHeightForWidth() ) );
	QualitySlider->setTickmarks( QSlider::Below );

    Layout4->addWidget( QualitySlider, 2, 1 );

	QualitySpin = new QSpinBox( 1, 300, 1, this, "QualitySpin" );
    QualitySpin->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, QualitySpin->sizePolicy().hasHeightForWidth() ) );
	QualitySpin->setFixedWidth( 60 );

	Layout4->addWidget( QualitySpin, 2, 2 );
/*
	QlValueLabel = new QLabel( this, "QlLabelValue" );
    QlValueLabel->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, QlValueLabel->sizePolicy().hasHeightForWidth() ) );
	QlValueLabel->setFixedWidth( 55 );
	QlValueLabel->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QlValueLabel->setAlignment( Qt::AlignCenter );
	QlValueLabel->setText( "1" );

	Layout4->addWidget( QlValueLabel, 2, 2 );
*/
    GoButton = new QPushButton( this, "GoButton" );
    GoButton->setSizePolicy( QSizePolicy( QSizePolicy::Maximum, QSizePolicy::Minimum, GoButton->sizePolicy().hasHeightForWidth() ) );
    QFont GoButton_font(  GoButton->font() );
    GoButton_font.setFamily( "Arial" );
    GoButton_font.setPointSize( 16 );
	GoButton_font.setWeight( QFont::Black );
    GoButton->setFont( GoButton_font ); 
    GoButton->setText( tr( "GO!" ) );

    Layout4->addMultiCellWidget( GoButton, 0, 2, 3, 3 );

    BaseLayout->addLayout( Layout4 );

	ResultCtrl = new QTabWidget( this, "ResultCtrl" );
	ResultCtrl->setMargin( 3 );

	StepView = new QScrollView( this, "StepView" );
    StepView->setHScrollBarMode( QScrollView::AlwaysOff );
	StepView->setVScrollBarMode( QScrollView::AlwaysOn );
	ResultCtrl->addTab( StepView, "Steps" );
	StepList = NULL;

	SummaryBox = new QVBox( this );
	SummaryBox->setSpacing( 4 );
	SummaryBox->setMargin( 1 );

	ItemsBox = new QGroupBox( SummaryBox, "ItemsBox" );
	ItemsBox->setTitle( tr( "Needed items:" ) );
	ItemsBox->setColumnLayout( 0, Qt::Vertical );
	ItemsBox->layout()->setSpacing( 0 );
	ItemsBox->layout()->setMargin( 0 );
	ItemsBoxLayout = new QVBoxLayout( ItemsBox->layout() );
	ItemsBoxLayout->setAlignment( Qt::AlignTop );
	ItemsBoxLayout->setSpacing( 4 );
	ItemsBoxLayout->setMargin( 6 );

	ItemsList = new QListView( ItemsBox, "ItemsList" );
    ItemsList->header()->setClickEnabled( TRUE );
    ItemsList->header()->setResizeEnabled( FALSE );
    ItemsList->addColumn( tr( "Item" ), 300 );
    ItemsList->addColumn( tr( "Min. QL" ), 60 );
	ItemsList->addColumn( tr( "Amount" ), 60 );
	ItemsList->setSelectionMode( QListView::Single );
	ItemsList->setAllColumnsShowFocus( TRUE );
	ItemsList->setShowSortIndicator( TRUE );
	ItemsList->setLineWidth( 1 );
	ItemsBoxLayout->addWidget( ItemsList );

	NoteLabel = new QLabel( SummaryBox, "NoteLabel" );
	NoteLabel->setText( tr( "QL's marked with a <b>*</b> are fixed, meaning the only exist at this value" ) );

	SkillsBox = new QGroupBox( SummaryBox, "SkillsBox" );
	SkillsBox->setTitle( tr( "Needed skills:" ) );
	SkillsBox->setColumnLayout( 0, Qt::Vertical );
	SkillsBox->layout()->setSpacing( 0 );
	SkillsBox->layout()->setMargin( 0 );
	SkillsBoxLayout = new QVBoxLayout( SkillsBox->layout() );
	SkillsBoxLayout->setAlignment( Qt::AlignTop );
	SkillsBoxLayout->setSpacing( 4 );
	SkillsBoxLayout->setMargin( 6 );

	SkillsList = new QListView( SkillsBox, "SkillsList" );
    SkillsList->header()->setClickEnabled( TRUE );
    SkillsList->header()->setResizeEnabled( FALSE );
    SkillsList->addColumn( tr( "Skill" ), 300 );
    SkillsList->addColumn( tr( "Amount" ), 60 );
	SkillsList->setSelectionMode( QListView::Single );
	SkillsList->setAllColumnsShowFocus( TRUE );
	SkillsList->setShowSortIndicator( TRUE );
	SkillsList->setLineWidth( 1 );
	SkillsBoxLayout->addWidget( SkillsList );

	ResultCtrl->addTab( SummaryBox, "Summary" );

	BaseLayout->addWidget( ResultCtrl );

    Layout1 = new QHBoxLayout; 
    Layout1->setSpacing( 6 );
    Layout1->setMargin( 0 );

    AboutButton = new QPushButton( this, "AboutButton" );
    AboutButton->setText( tr( "&About" ) );
    AboutButton->setAutoDefault( FALSE );
    Layout1->addWidget( AboutButton );
    QSpacerItem* spacer_3 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer_3 );

	QAccel * AboutAccel = new QAccel( this );
	AboutAccel->connectItem( AboutAccel->insertItem( Key_F1 ), this, SLOT( aboutClicked() ) );

    ExitButton = new QPushButton( this, "ExitButton" );
    ExitButton->setCaption( tr( "" ) );
    ExitButton->setText( tr( "&Exit" ) );
    Layout1->addWidget( ExitButton );
    BaseLayout->addLayout( Layout1 );

    // signals and slots connections
    connect( GoButton, SIGNAL( clicked() ), this, SLOT( goClicked() ) );
    connect( AboutButton, SIGNAL( clicked() ), this, SLOT( aboutClicked() ) );
    connect( ExitButton, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( ProcGrpList, SIGNAL( activated(int) ), this, SLOT( procGrpChanged(int) ) );
    connect( ProcessList, SIGNAL( activated(int) ), this, SLOT( processChanged(int) ) );
	connect( QualitySlider, SIGNAL( valueChanged(int) ), this, SLOT( qualityChanged(int) ) );
	connect( QualitySpin, SIGNAL( valueChanged(int) ), this, SLOT( qualityChanged(int) ) );

    // tab order
    setTabOrder( ProcGrpList, ProcessList );
    setTabOrder( ProcessList, QualitySlider );
	setTabOrder( QualitySlider, QualitySpin );
    setTabOrder( QualitySpin, AboutButton );
    setTabOrder( AboutButton, ExitButton );

	// "What's this?" texts
    QWhatsThis::add( ProcGrpList, tr( "Select the tradeskill group you wish to use.\nBe sure to select the right process type aswell, before pressing \"Go\"." ) );
    QWhatsThis::add( ProcessList, tr( "Select the type of the process you wish to use (The tradeskill group might only contain 1 process type)." ) );
    QWhatsThis::add( QualitySlider, tr( "Select the quality of the tradeskill product." ) );
    QWhatsThis::add( QualitySpin, tr( "Select the quality of the tradeskill product." ) );
    QWhatsThis::add( GoButton, tr( "Calculated the needed tools, items and skills required to complete the selected tradeskill process." ) );

	updateProcGrpList();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCrafterDialog::~AOCrafterDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool AOCrafterDialog::event( QEvent* ev )
{
    bool ret = QDialog::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange )
	{
		QFont GoButton_font(  GoButton->font() );
		GoButton_font.setFamily( "Arial" );
		GoButton_font.setPointSize( 16 );
		GoButton_font.setWeight( QFont::Black );
		GoButton->setFont( GoButton_font ); 
    }
    return ret;
}

void AOCrafterDialog::updateProcGrpList()
{
	ProcGrpList->clear();
	if( Procs.getProcGroups() )
	{
		for( int n = 0; n < Procs.getProcGroups(); n++ )
		{
			ProcGrpList->insertItem( Procs.getProcGroup( n ) );
		}
	}
	if( Procs.getProcGroups() <= 1 )
	{
		ProcGrpList->setEnabled( FALSE );
	}
	else
	{
		ProcGrpList->setEnabled( TRUE );
	}
	updateProcList();
}

void AOCrafterDialog::updateProcList()
{
	ProcessList->clear();
	Procs.setProcGroup( ProcGrpList->currentItem() );
	if( Procs.getProcesses() )
	{
		for( int n = 0; n < Procs.getProcesses(); n++ )
		{
			ProcessList->insertItem( Procs.getProcess( n ).Name );
		}
	}
	if( Procs.getProcesses() <= 1 )
	{
		ProcessList->setEnabled( FALSE );
	}
	else
	{
		ProcessList->setEnabled( TRUE );
	}
	processChanged( 0 );
}

void AOCrafterDialog::goClicked()
{
	double QL = (double) QualitySlider->value();
	Procs.setProcGroup( ProcGrpList->currentItem() );
	aocDebug( "Calculating requirements for making a QL %.0f %s", QL,
		Procs.getProcess( ProcessList->currentItem() ).Name.latin1() );
	aocDebug( " Steps to process: %d", Procs.getSteps() );

	if( StepList != NULL )
		StepList->~QVBox();
	StepList = NULL;
	StepList = new QVBox( StepView->viewport() );
//	StepList->setFixedSize( 510, 600 * Procs.getSteps( grp, proc ) );
	StepView->addChild( StepList );

	ItemsList->clear();
	SkillsList->clear();
	Items.clear();
	Skills.clear();

	for( int n = 0; n < Procs.getSteps(); n++ )
	{
		aocDebug( "  Step %d:", n );

		aocDebug( "   Calculating items..." );
		AOCStep Step = Procs.getStep( n );

		/* calculate min. QL for item 1 */
		if( Step.Item1.Multiplier == 0.0 )
			Step.Item1.Value = Procs.getItemByID( Step.Item1.AOC_ID ).MinQL;
		else
			Step.Item1.Value = QMAX( qRound( QL * Step.Item1.Multiplier ), 1 );
		aocDebug( "    Item 1: Value=%d", Step.Item1.Value );

		/* calculate min. QL for item 2 */
		if( Step.Item2.Multiplier == 0.0 )
			Step.Item2.Value = Procs.getItemByID( Step.Item2.AOC_ID ).MinQL;
		else
			Step.Item2.Value = QMAX( qRound( QL * Step.Item2.Multiplier ), 1 );
		aocDebug( "    Item 2: Value=%d", Step.Item2.Value );

		/* calculate min. QL for product */
		if( Step.Product.Multiplier == 0.0 )
			Step.Product.Value = Procs.getItemByID( Step.Product.AOC_ID ).MinQL;
		else
			Step.Product.Value = QMAX( qRound( QL * Step.Product.Multiplier ), 1 );
		aocDebug( "    Product: Value=%d", Step.Product.Value );

		/* check if items are a product of another step */
		int OneIsProduct = FALSE;
		int TwoIsProduct = FALSE;
		for( int m = 0; m < Procs.getSteps(); m++ )
		{
			if( Step.Item1.AOC_ID == Procs.getStep( m ).Product.AOC_ID )
				OneIsProduct = TRUE;
			if( Step.Item2.AOC_ID == Procs.getStep( m ).Product.AOC_ID )
				TwoIsProduct = TRUE;
		}
		if( !OneIsProduct )
		{
			Step.Item1.Count = Step.Count;
			Items.append( Step.Item1 );
		}
		if( !TwoIsProduct )
		{
			Step.Item2.Count = Step.Count;
			Items.append( Step.Item2 );
		}

		aocDebug( "   Calculating skills..." );
		QListViewItem * Skill = 0;
		for( int n = 0; n < (int) Step.Skills.count(); n++ )
		{
			Step.Skills[n].Value = QMAX( qRound( Step.Skills[n].Multiplier * Step.Product.Multiplier * QL ), 1 );
			Skills.append( Step.Skills[n] );
		}

		aocDebug( "   Setting up steps window..." );
		AOCStepWidget *stepW = new AOCStepWidget( StepList );
		stepW->setStep( Step, n );
	}
	StepView->showChild( StepList, TRUE );

	aocDebug( "   Trimming items and skills lists..." );
	Items = Procs.makeUnique( Items );
	Skills = Procs.makeUnique( Skills );

	aocDebug( "   Setting up summary window..." );
	QListViewItem * item = 0;
	for( int i = 0; i < (int) Items.count(); i++ )
	{
		item = new QListViewItem( ItemsList, item );
		item->setText( 0, Procs.getItemByID( Items[i].AOC_ID ).Name );

		if( Items[i].Multiplier == 0.0 )
			item->setText( 1, QString( "%1 *" ).arg( Procs.getItemByID( Items[i].AOC_ID ).MinQL ) );
		else
			item->setText( 1, QString( "%1" ).arg( Items[i].Value ) );

		item->setText( 2, QString( "%1" ).arg( Items[i].Count ) );
	}
	item = 0;
	for( int s = 0; s < (int) Skills.count(); s++ )
	{
		item = new QListViewItem( SkillsList, item );
		item->setText( 0, QString( "%1" ).arg( Names.getSkill( Skills[s].AOC_ID ) ) );
		item->setText( 1, QString( "%1" ).arg( Skills[s].Value ) );
	}
}

void AOCrafterDialog::aboutClicked()
{
	AOCAboutDlg AboutDlg( 0, 0, TRUE, Qt::WStyle_Customize | Qt::WStyle_DialogBorder | Qt::WStyle_Title | Qt::WStyle_SysMenu );
	AboutDlg.exec();
}

void AOCrafterDialog::itemClicked(QListViewItem*)
{
    qWarning( "AOCrafterDialog::itemClicked(QListViewItem*): Not implemented yet!" );
}

void AOCrafterDialog::procGrpChanged(int)
{
	updateProcList();
}

void AOCrafterDialog::processChanged(int)
{
	AOCProc selProc;
	Procs.setProcGroup( ProcGrpList->currentItem() );
	selProc = Procs.getProcess( ProcessList->currentItem() );
	int tmpQl = QualitySlider->value();

	aocDebug( "Selected: %s (ql %d-%d)", selProc.Name.latin1(), selProc.MinQL, selProc.MaxQL );
	QualitySlider->setMinValue( selProc.MinQL );
	QualitySlider->setMaxValue( selProc.MaxQL );
	QualitySpin->setMinValue( selProc.MinQL );
	QualitySpin->setMaxValue( selProc.MaxQL );
	if( tmpQl > selProc.MaxQL )
		tmpQl = selProc.MaxQL;
	else if( tmpQl < selProc.MinQL )
		tmpQl = selProc.MinQL;
	qualityChanged( tmpQl );
	if( selProc.MaxQL == selProc.MinQL )
	{
//		QlValueLabel->setText( tr( "* Special *" ) );
		QualitySlider->setEnabled( FALSE );
		QualitySpin->setEnabled( FALSE );
		QualitySpin->setSpecialValueText( "Special" );
	}
	else
	{
//		QlValueLabel->setText( tr( "%1" ).arg( QualitySlider->value() ) );
		QualitySlider->setEnabled( TRUE );
		QualitySpin->setEnabled( TRUE );
		QualitySpin->setSpecialValueText( "" );
	}
}

void AOCrafterDialog::qualityChanged( int QL )
{
//	QlValueLabel->setText( tr( "%1" ).arg( QL ) );
	QualitySlider->setValue( QL );
	QualitySpin->setValue( QL );
}


/* 
 *  Constructs a AOCStepWidget which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AOCStepWidget::AOCStepWidget( QWidget* parent,  const char* name, WFlags fl )
    : QVBox( parent, name, fl )
{
	aocDebug( "[**]  Making Step Widget" );
	setFrameShape( QFrame::Panel );
	setFrameShadow( QFrame::Raised );
	setLineWidth( 2 );
	setFixedSize( 500, 150 );
	setSpacing( 4 );
	setMargin( 4 );

	StepLabel = new QLabel( this, "StepLabel" );
	StepLabel->setText( "<i>**StepLabel**</i>" );

	StepSkills = new QListView( this, "StepSkills" );
    StepSkills->setSizePolicy( QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Fixed, StepSkills->sizePolicy().hasHeightForWidth() ) );
	StepSkills->setFixedSize( 488, 75 );
    StepSkills->header()->setClickEnabled( TRUE );
    StepSkills->header()->setResizeEnabled( FALSE );
    StepSkills->addColumn( tr( "Skill" ), 300 );
    StepSkills->addColumn( tr( "Amount" ), 60 );
	StepSkills->setSelectionMode( QListView::Single );
	StepSkills->setAllColumnsShowFocus( TRUE );
	StepSkills->setShowSortIndicator( TRUE );
	StepSkills->setLineWidth( 1 );
	aocDebug( "[!!]  Done" );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AOCStepWidget::~AOCStepWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

void AOCStepWidget::setStep( AOCStep Step, int n = 0 )
{
	QString StepText;
	QString Item1QL;
	QString Item2QL;
	QString ProductQL;
	QString Repeats = "";

	if( Step.Item1.Multiplier == 0.0 ) Item1QL = QString( "Fixed QL %1" ).arg( Step.Item1.Value );
	else Item1QL = QString( "Min. QL %1" ).arg( Step.Item1.Value );

	if( Step.Item2.Multiplier == 0.0 ) Item2QL = QString( "Fixed QL %1" ).arg( Step.Item2.Value );
	else Item2QL = QString( "Min. QL %1" ).arg( Step.Item2.Value );

	if( Step.Product.Multiplier == 0.0 ) ProductQL = QString( "Fixed QL %1" ).arg( Step.Product.Value );
	else ProductQL = QString( "Min. QL %1" ).arg( Step.Product.Value );

	if( Step.Count > 1 ) Repeats = QString( "<font color=red>Repeat %1 times!</font>" ).arg( Step.Count );

	StepText.append( QString( "<b><i>Step %1:  %2</i></b><br>\n" ).arg( n + 1 ).arg( Repeats ) );
	StepText.append( QString( "%1 " ).arg( Names.getAction( Step.Action ) ) );
	StepText.append( QString( "<font color=darkgreen><b>%2</b></font> (<font color=darkblue>%3</font>)<br>\n"
		).arg( Procs.getItemByID( Step.Item1.AOC_ID ).Name ).arg( Item1QL ) );
	StepText.append( QString( "on <font color=darkgreen><b>%4</b></font> (<font color=darkblue>%4</font>)<br>\n"
		).arg( Procs.getItemByID( Step.Item2.AOC_ID ).Name ).arg( Item2QL ) );
	StepText.append( QString( "This makes a <font color=darkgreen><b>%1</b></font> (<font color=darkblue>%2</font>)"
		).arg( Procs.getItemByID( Step.Product.AOC_ID ).Name ).arg( ProductQL ) );
	if( !Step.Note.isEmpty() )
	{
		setFixedSize( 500, 180 );
		StepText.append( QString( "<br><font color=red><i>Note: %1</i></font>" ).arg( Step.Note ) );
	}

	StepLabel->setText( StepText );

	QListViewItem * skill = 0;
	for( int s = 0; s < (int) Step.Skills.count(); s++ )
	{
		skill = new QListViewItem( StepSkills, skill );
		skill->setText( 0, QString( "%1" ).arg( Names.getSkill( Step.Skills[s].AOC_ID ) ) );
		skill->setText( 1, QString( "%1" ).arg( Step.Skills[s].Value ) );
	}
}
