/****************************************************************************
** Form interface generated from reading ui file '.\AOCrafterStepDialog.ui'
**
** Created: Thu Jan 22 17:07:21 2004
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef STEP_DLG_H
#define STEP_DLG_H

#include <qvariant.h>
#include <qdialog.h>
#include "../common/aoc_proc.h"
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QComboBox;
class QFrame;
class QGroupBox;
class QLabel;
class QLineEdit;
class QListView;
class QListViewItem;
class QPushButton;
class QMultiLineEdit;
class QSpinBox;

class AOCrafterStepDialog : public QDialog
{ 
    Q_OBJECT

public:
    AOCrafterStepDialog( ItemList items, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AOCrafterStepDialog();

    QFrame* StepFrame;
    QComboBox* ActionBox;
    QLabel* Item1Box;
    QPushButton* EditItem1Btn;
    QLabel* OnLabel;
    QLabel* Item2Box;
    QPushButton* EditItem2Btn;
    QLabel* ProductLabel;
    QLabel* ProductBox;
    QPushButton* EditProductBtn;
    QGroupBox* SkillBox;
    QListView* SkillsList;
    QPushButton* EditSkillBtn;
    QPushButton* DelSkillBtn;
    QGroupBox* ReqFrame;
    QLabel* NameLabel;
    QComboBox* NameBox;
    QLabel* MultiLabel;
    QLineEdit* MultiEdit;
    QCheckBox* FixedBox;
    QPushButton* AddBtn;
	QLabel* CountLabel;
	QSpinBox* CountBox;
	QGroupBox* NoteBox;
	QMultiLineEdit* NoteEdit;
	QPushButton* SaveNoteBtn;
    QPushButton* OkBtn;
    QPushButton* CancelBtn;

	AOCStep step;
	void updateData();

protected slots:
    virtual void addItem();
    virtual void deleteSkill();
    virtual void editItem1();
    virtual void editItem2();
    virtual void editProduct();
    virtual void editSkill();
    virtual void setFixed(bool);
	virtual void setAction(int);
	virtual void setCount(int);
	virtual void saveNote();

protected:
    QVBoxLayout* AOCrafterStepDialogLayout;
    QGridLayout* StepFrameLayout;
    QHBoxLayout* SkillBoxLayout;
    QVBoxLayout* SkillsLayout;
	QHBoxLayout* CountLayout;
    QVBoxLayout* NoteBoxLayout;
    QHBoxLayout* SysLayout;
    QGridLayout* ReqFrameLayout;

	enum EditModes {
		AddSkill	= 0x0000,
		EditSkill	= 0x0001,
		EditItem1	= 0x0002,
		EditItem2	= 0x0003,
		EditProduct	= 0x0004
	};

	int getItemIndexByID(Q_UINT32);
	AOCItem getItemByIndex(int);
	AOCItem getItemByID(Q_UINT32);
	void listItems(bool);

	EditModes EditMode;
	ItemList AvailItems;
	int selSkill;
};

#endif // STEP_DLG_H
