/****************************************************************************
** Form interface generated from reading ui file 'ui-files\client_dlg.ui'
**
** Created: Wed Oct 8 19:49:31 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef CLIENT_DLG_H
#define CLIENT_DLG_H

#include <qvariant.h>
#include <qdialog.h>
#include <qvbox.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QComboBox;
class QGroupBox;
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;
class QSlider;
class QSpinBox;
class QScrollView;
class QTabWidget;

#include "../common/aoc_proc.h"

class AOCrafterDialog : public QDialog
{ 
    Q_OBJECT

public:
    AOCrafterDialog( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AOCrafterDialog();

    QLabel* ProcGrpLabel;
    QLabel* ProcessLabel;
    QLabel* QualityLabel;
    QComboBox* ProcGrpList;
    QComboBox* ProcessList;
	QSlider* QualitySlider;
	QSpinBox* QualitySpin;
    QLabel* QlValueLabel;
    QPushButton* GoButton;
	QTabWidget* ResultCtrl;
	QScrollView* StepView;
	QVBox* StepList;
	QVBox* SummaryBox;
    QGroupBox* ItemsBox;
    QListView* ItemsList;
	QLabel* NoteLabel;
    QGroupBox* SkillsBox;
    QListView* SkillsList;
    QPushButton* AboutButton;
    QPushButton* ExitButton;

protected slots:
    virtual void goClicked();
    virtual void aboutClicked();
    virtual void itemClicked(QListViewItem*);
    virtual void procGrpChanged(int);
    virtual void processChanged(int);
	virtual void qualityChanged(int);

	void updateProcGrpList();
	void updateProcList();

protected:
    QVBoxLayout* BaseLayout;
    QVBoxLayout* ItemsBoxLayout;
    QVBoxLayout* SkillsBoxLayout;
    QHBoxLayout* Layout1;
    QGridLayout* Layout4;
    bool event( QEvent* );

	ReqsList Items;
	ReqsList Skills;
};

class AOCStepWidget : public QVBox
{ 
    Q_OBJECT

public:
    AOCStepWidget( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~AOCStepWidget();

	void setStep( AOCStep Step, int n );

protected:
	QLabel* StepLabel;
	QListView* StepSkills;
};

#endif // CLIENT_DLG_H
